config/routes.rb
Rails.application.routes.draw do
  root to: 'home#index'

  resources :movies
  resources :tv_shows
end

app/models/acting_credit.rb
class ActingCredit < Credit
  alias_attribute :character, :role

  def self.top_billing
    includes(:person).first(5)
  end
end

app/models/administrator.rb
class Administrator < ApplicationRecord
  include Trestle::Auth::ModelMethods
  include Trestle::Auth::ModelMethods::Rememberable

  # Prevent demo user from being modified
  validate on: :update do
    errors.add(:email, "Cannot change login details for demo user") if demo? && email_changed?
    errors.add(:password, "Cannot change login details for demo user") if demo? && password_digest_changed?
  end

  before_destroy if: :demo? do
    throw(:abort)
  end

  def demo?
    email_was == "demo@example.com"
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true

protected
  def tmdb_image(path, version="original")
    "https://image.tmdb.org/t/p/#{version}#{path}"
  end
end

app/models/concerns/media.rb
module Media
  extend ActiveSupport::Concern

  included do
    has_many :acting_credits, -> { actors.ordered }, as: :media
    has_many :crew_credits, -> { crew }, as: :media

    has_many :directing_credits, -> { crew.directors }, as: :media, class_name: "CrewCredit"
    has_many :directors, -> { alphabetical }, through: :directing_credits, source: :person

    has_one :lead_directing_credit, -> { crew.directors }, as: :media, class_name: "CrewCredit"
    has_one :lead_director, -> { alphabetical }, through: :lead_directing_credit, source: :person

    has_many :videos, as: :media
    has_many :images, as: :media

    scope :posters, -> { where.not(poster_path: [nil, ""]).select(:poster_path) }
  end

  def score
    (vote_average * 10).to_i
  end

  def media_count
    count = videos.count + images.count
    count += 1 if backdrop?
    count
  end

  def poster?
    poster_path.present?
  end

  def poster_url(version="original")
    tmdb_image(poster_path, version)
  end

  def poster_count
    count = images.posters.count
    poster? ? count + 1 : count
  end

  def backdrop?
    backdrop_path.present?
  end

  def backdrop_url(version="original")
    tmdb_image(backdrop_path, version)
  end

  def backdrop_count
    count = images.backdrops.count
    backdrop? ? count + 1 : count
  end

  def trailer
    videos.find_by(video_type: "Trailer")
  end
end

app/models/credit.rb
class Credit < ApplicationRecord
  belongs_to :media, polymorphic: true
  belongs_to :person

  scope :ordered, -> { order(order: :asc) }

  scope :actors, -> { where(type: "ActingCredit") }
  scope :crew, -> { where(type: "CrewCredit") }

  delegate :name, :initials, :gender, :profile?, :profile_url, :profile_path, to: :person, allow_nil: true
end

app/models/crew_credit.rb
class CrewCredit < Credit
  alias_attribute :job, :role

  scope :directors, -> { where(job: "Director") }
end

app/models/genre.rb
class Genre < ApplicationRecord
  scope :alphabetical, -> { order(name: :asc) }

  validates :name, presence: true
end

app/models/image.rb
class Image < ApplicationRecord
  belongs_to :media, polymorphic: true

  scope :posters, -> { where(image_type: "Poster") }
  scope :backdrops, -> { where(image_type: "Backdrop") }

  def url(version="original")
    tmdb_image(file_path, version)
  end
end

app/models/movie.rb
class Movie < ApplicationRecord
  include Media

  include PgSearch::Model
  pg_search_scope :pg_search, against: [:title, :tagline, :overview], using: { tsearch: { prefix: true, tsvector_column: "tsv" } }

  STATUSES = [
    "Rumored",
    "Planned",
    "In Production",
    "Post Production",
    "Released",
    "Canceled"
  ]

  has_and_belongs_to_many :genres, -> { alphabetical }, class_name: "Movie::Genre"

  validates :title, :status, presence: true
  validates :tmdb_id, uniqueness: { allow_blank: true }

  def tmdb_url
    "https://www.themoviedb.org/movie/#{tmdb_id}"
  end

  def imdb_url
    "https://www.imdb.com/title/#{imdb_id}"
  end

  def to_param
    [id, title.parameterize].join("-")
  end
end

app/models/movie/genre.rb
class Movie::Genre < Genre
  def media
    "Movie"
  end
end

app/models/person.rb
class Person < ApplicationRecord
  include PgSearch::Model
  pg_search_scope :pg_search, against: [:name], using: { tsearch: { prefix: true, tsvector_column: "tsv" } }

  has_many :credits

  scope :alphabetical, -> { order(name: :asc) }

  validates :name, presence: true
  validates :tmdb_id, uniqueness: { allow_blank: true }

  enum gender: { "Not specified" => 0, "Female" => 1, "Male" => 2, "Non-Binary" => 3 }

  def initials
    name.split.map(&:first).join
  end

  def profile?
    profile_path.present?
  end

  def profile_url(version="original")
    tmdb_image(profile_path, version)
  end
end

app/models/tv_show.rb
class TVShow < ApplicationRecord
  include Media

  include PgSearch::Model
  pg_search_scope :pg_search, against: [:name, :overview], using: { tsearch: { prefix: true, tsvector_column: "tsv" } }

  STATUSES = [
    'Returning Series',
    'Planned',
    'In Production',
    'Ended',
    'Canceled',
    'Pilot'
  ]

  has_many :seasons, -> { ordered }, inverse_of: :tv_show

  has_and_belongs_to_many :genres, -> { alphabetical }, class_name: "TVShow::Genre"

  validates :name, :status, presence: true
  validates :tmdb_id, uniqueness: { allow_blank: true }

  def tmdb_url
    "https://www.themoviedb.org/tv/#{tmdb_id}"
  end
end

app/models/tv_show/genre.rb
class TVShow::Genre < Genre
  def media
    "TV Show"
  end
end

app/models/video.rb
class Video < ApplicationRecord
  belongs_to :media, polymorphic: true

  def url
    case site
    when "YouTube"
      "https://www.youtube.com/watch?v=#{key}"
    end
  end

  def thumbnail
    case site
    when "YouTube"
      "https://img.youtube.com/vi/#{key}/hqdefault.jpg"
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
    @posters = (Movie.posters + TVShow.posters).shuffle.first(200)
  end
end

app/controllers/media_controller.rb
class MediaController < ApplicationController
protected
  def paginate(klass)
    klass.page(params[:page]).per(10)
  end
end

app/controllers/movies_controller.rb
class MoviesController < MediaController
  def index
    @movies = paginate(Movie)
  end

  def show
    @movie = Movie.find(params[:id])

    @credits   = @movie.acting_credits.includes(:person)
    @videos    = @movie.videos
    @posters   = @movie.images.posters
    @backdrops = @movie.images.backdrops
  end
end

app/controllers/tv_shows_controller.rb
class TVShowsController < MediaController
  def index
    @tv_shows = paginate(TVShow)
  end

  def show
    @tv_show = TVShow.find(params[:id])

    @credits   = @tv_show.acting_credits.includes(:person)
    @seasons   = @tv_show.seasons
    @videos    = @tv_show.videos
    @posters   = @tv_show.images.posters
    @backdrops = @tv_show.images.backdrops
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/admin/shared/_media.html.erb
<h3>Videos</h3>

<ul class="media-grid" data-behavior="video-gallery">
  <% instance.videos.each do |video| %>
    <li>
      <figure class="fill zoom aspect-ratio-16x9">
        <%= link_to image_tag(video.thumbnail), video.url %>
      </figure>
    </li>
  <% end %>
</ul>

<h3>Posters</h3>

<ul class="media-grid" data-behavior="gallery">
  <% instance.images.posters.each do |image| %>
    <li>
      <figure class="zoom">
        <%= link_to image_tag(image.url("w500")), image.url %>
      </figure>
    </li>
  <% end %>
</ul>

<h3>Backdrops</h3>

<ul class="media-grid" data-behavior="gallery">
  <% if instance.backdrop? %>
    <li>
      <figure class="fill zoom aspect-ratio-16x9">
      <%= link_to image_tag(instance.backdrop_url("w780")), instance.backdrop_url %>
      </figure>
    </li>
  <% end %>

  <% instance.images.backdrops.each do |image| %>
    <li>
      <figure class="fill zoom aspect-ratio-16x9">
        <%= link_to image_tag(image.url("w780")), image.url %>
      </figure>
    </li>
  <% end %>
</ul>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title><%= [content_for(:title), "Rails Flix - Trestle demo application"].compact.join(" | ") %></title>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width">

    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>

    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.2/css/all.css" integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr" crossorigin="anonymous">
  </head>

  <body>
    <nav class="navbar navbar-dark bg-dark navbar-expand-md">
      <%= link_to "Rails Flix", "/", class: "navbar-brand" %>

      <%= button_tag class: "navbar-toggler", data: { toggle: "collapse", target: "#primary-nav" }, aria: { controls: "primary-nav", expanded: false, label: "Toggle navigation" } do %>
        <span class="navbar-toggler-icon"></span>
      <% end %>

      <div class="collapse navbar-collapse" id="primary-nav">
        <ul class="navbar-nav">
          <li class="nav-item"><%= link_to "Movies", movies_path, class: "nav-link" %></li>
          <li class="nav-item"><%= link_to "TV Shows", tv_shows_path, class: "nav-link" %></li>
        </ul>

        <%= link_to "/admin", class: "btn btn-primary rounded-pill ml-auto" do %>
          <i class="fas fa-lock"></i>
          Admin Login
        <% end %>

        <%= link_to image_tag("trestle.svg", alt: "Trestle"), "https://trestle.io", target: "_blank", class: "trestle-logo" %>
      </div>
    </nav>

    <div class="page-main">
      <%= yield %>
    </div>

    <div class="page-footer bg-dark">
      <p>Copyright &copy; <%= Date.today.year %> Sam Pohlenz — All rights reserved.</p>
      <p class="text-muted">This product uses the TMDb API but is not endorsed or certified by TMDb.</p>
    </div>
  </body>
</html>